/*
 *	General functions.
 */

#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <math.h>

#include "hr_defines.h"
#include "hr_colors.h"
#include "hr_general.h"


/* Floodfill. Uses recursion. FIX! int flags-->####*/
void hr_floodfill(int x,int y,int c,int rc,int flags)
{
	gl_setpixel(x,y,c);
	switch(flags)   {
	 case 0:
		/* Mode 0 - Recolor color rc */
		if(vga_getpixel(x-1,y)==rc)
		  hr_floodfill(x-1,y,c,rc,flags);
		if(vga_getpixel(x+1,y)==rc)
		  hr_floodfill(x+1,y,c,rc,flags);
		if(vga_getpixel(x,y-1)==rc)
		  hr_floodfill(x,y-1,c,rc,flags);
		if(vga_getpixel(x,y+1)==rc)
		  hr_floodfill(x,y+1,c,rc,flags);
		break;
	 case 1:
		/* Mode 1 - Stop coloring at color rc */
		if(vga_getpixel(x-1,y)!=rc)
		  hr_floodfill(x-1,y,c,rc,flags);
		if(vga_getpixel(x+1,y)!=rc)
		  hr_floodfill(x+1,y,c,rc,flags);
		if(vga_getpixel(x,y-1)!=rc)
		  hr_floodfill(x,y-1,c,rc,flags);
		if(vga_getpixel(x,y+1)!=rc)
		  hr_floodfill(x,y+1,c,rc,flags);
		break;
	}
}


/* Replaces colors on range c1-c2 with nc.*/
void hr_replace_colors(int x1,int y1,int x2,int y2,int c1,int c2,int nc)
{
	int x,y,c;
	for(y=y1;y<=y2;y++){
		for(x=x1;x<=x2;x++){
			c=vga_getpixel(x,y);
			if((c>=c1) && (c<=c2))
			  gl_setpixel(x,y,nc);
		}
	}
}


/* Circle.... useless...
 * Calcs 1/8 of dots, mirrors the rest.*/
#define CIRCLE_STEP 3
void hr_circle(int x,int y,int r,int c,int flags)
{
	int a,xp,yp,div;
	if(r>0){
		if(flags & GFX_FAST){
			div=(1<<SCALE)/r;
			for(a=0;a<=45;a+=CIRCLE_STEP){
				xp=pcos[a]/div;
				yp=psin[a]/div;
				gl_setpixel(x+xp,y+yp,c);
				gl_setpixel(x-xp,y+yp,c);
				gl_setpixel(x+xp,y-yp,c);
				gl_setpixel(x-xp,y-yp,c);
				/* Swap x and y.*/
				gl_setpixel(x+yp,y+xp,c);
				gl_setpixel(x-yp,y+xp,c);
				gl_setpixel(x+yp,y-xp,c);
				gl_setpixel(x-yp,y-xp,c);
			}
		}
	}
}


/* Draws a filled disc.*/
void hr_disc(int x,int y,int r,int c,int flags)
{
	int xx,yy,r2;
	if(r>0){
		r2=r*r;
		gl_hline(x-r,y,x+r,c);
		for(yy=1;yy<=r;yy++){
			xx=(int)(sqrt((double)(r2-(yy*yy))));
			gl_hline(x-xx,y-yy,x+xx,c);
			gl_hline(x-xx,y+yy,x+xx,c);
		}
	}
}


/* Draws a line.*/
void hr_drawline(int x1,int y1,int x2,int y2,int c,int flags)
{
	return;
}


/* Draws an ellipse.*/
void hr_ellipse(int x,int y,int a1,int a2,int c,int flags)
{
	return;
}


/* Sets a pixel.*/
void hr_setpixel(int x,int y,int c,int flags)
{
	return;
}


/* Returns color of a pixel.*/
void hr_getpixel(int x,int y,int c,int flags)
{
	return;
}


/* Draws a filled box.*/
void hr_fillbox(int x,int y,int width,int height,int c,int flags)
{
	return;
}


/* Draws a hollow box.*/
void hr_box(int x1,int y1,int x2,int y2,int c,int flags)
{
	gl_hline(x1,y1,x2,c);
	if(y1!=y2){
		gl_hline(x1,y2,x2,c);
		if(y2>(y1+1)){
			gl_line(x1,y1+1,x1,y2-1,c);
			gl_line(x2,y1+1,x2,y2-1,c);
		}
	}
	return;
}


/* Draws an arc.*/
void hr_arc(int x,int y,int a1,int a2,int angle1,int angle2,int c,int flags)
{
	return;
}


/* Draws a nice bevelbox ("3D" box, light source topleft.) */
void hr_bevelbox(int x1,int y1,int x2,int y2,
					  struct hr_color *colors,int flags)
{
	int c1,c2;
	/* Set colors */
	if(flags & BUTTON_PRESSED){
		c1=hr_get_color_index(colors,COLOR_DARK);
		c2=hr_get_color_index(colors,COLOR_LIGHT);
	}
	else{
		c1=hr_get_color_index(colors,COLOR_LIGHT);
		c2=hr_get_color_index(colors,COLOR_DARK);
	}
	/* Draw the bevelbox. */
	gl_hline(x1,y1,x2,c1);
	gl_line(x1,y1,x1,y2,c1);
	gl_hline(x1+1,y2,x2,c2);
	gl_line(x2,y1+1,x2,y2-1,c2);
}
